=== docs/web/requirements.txt ===
markdown>=3.3
mdx_gh_links
mdx_truly_sane_lists>=1.3
mkdocs>=1.6.0
mkdocs-git-revision-date-plugin>=0.2
mkdocs-macros-plugin>=0.2.4
mkdocs-publisher
mkdocs-redirects>=1.2.1
mkdocs-unused-files
plantuml==0.3.0
plantuml-markdown
pymdown-extensions
